------------------------------------------
--------------- main.lua -----------------
------------------------------------------

local DEPTH = 4
local SPEED = 30

local w = application:getDeviceWidth()
local h = application:getDeviceHeight()

function whatDepth( value )
	for test = 1, 7 do
		if value < 12.5 * test then
			return test
		end
	end
	return 8
end

-- a 16x16 grid 
makeGrid( 16 )

local greenbar = Bitmap.new( Texture.new("images/green-bar.png" ) )
greenbar:setAnchorPoint( 0, 0.5 )

local greendot = Bitmap.new( Texture.new("images/green-dot.png") )
greendot:setAnchorPoint( 0.5, 0.5 )

local greenslider = Slider.new( greenbar, greendot )
greenslider:setValue( (100 * DEPTH - 50) / 8 )
local margin = ( w - greenbar:getWidth() ) / 2
greenslider:setPosition( margin, h - 180 )
stage:addChild( greenslider )

local bluebar = Bitmap.new( Texture.new("images/blue-bar.png") )
bluebar:setAnchorPoint( 0, 0.5 )

local bluedot = Bitmap.new( Texture.new("images/blue-dot.png") )
bluedot:setAnchorPoint( 0.5, 0.5 )

local blueslider = Slider.new( bluebar, bluedot )
blueslider:setValue( 100 * SPEED / 60 )
local margin = ( w - bluebar:getWidth() ) / 2
blueslider:setPosition( margin, h - 130 )
stage:addChild( blueslider )

local font1 = TTFont.new( "Fonts/arial.ttf", 24 )

local text1 = TextField.new( font1, "Hilbert Curve, Order of " .. DEPTH )
text1:setPosition( 20, w + 40 )
stage:addChild( text1 )

local text2 = TextField.new( font1, "Plotting speed: " .. SPEED )
text2:setPosition( 20, w + 80 )
stage:addChild( text2 )

stage:addEventListener( Event.ENTER_FRAME, 
	function()
		text1:setText( "Hilbert Curve, Order of " .. 
			whatDepth(greenslider:getValue()) )				-- range of [1, 8]
		text2:setText( "Plotting speed: " .. 
			math.floor(60 * blueslider:getValue() / 100) )	-- range of [0, 100]
	end
)

local up = Bitmap.new( Texture.new("Images/draw_up.png") )
up:setAnchorPoint( 0.5, 1 )

local dn = Bitmap.new( Texture.new("Images/draw_dn.png") )
dn:setAnchorPoint( 0.5, 1 )

local drawBtn = Button.new( up, dn )
drawBtn:setPosition( w / 2, h - 30 )
stage:addChild( drawBtn )

function onClick( e )
	local depth = whatDepth( greenslider:getValue() )
	local speed = 60 * blueslider:getValue() / 100
	if speed > 0 then
		clearPlotting()
		startPlotting( depth, speed )
	end
end

drawBtn:addEventListener( "click", onClick )
